import {Awaitable, UniversalPath} from '../util'
import {ExtolloAwareNodeModule} from './types'
import {BaseEvent} from './bus'

/**
 * An event indicating that an NPM package has been discovered
 * by the framework.
 *
 * Application services can listen for this event to register
 * various discovery logic (e.g. automatically boot units
 */
export class PackageDiscovered extends BaseEvent {
    constructor(
        public packageConfig: ExtolloAwareNodeModule,
        public packageJson: UniversalPath,
    ) {
        super()
    }

    eventName = '@extollo/lib.PackageDiscovered'

    shouldBroadcast(): Awaitable<boolean> {
        return false
    }
}
